require 'forwardable'

module Facile::Api
  module ForwardMethods
    include Forwardable

    def self.extended(base)
      base.instance_variable_set(:@response, nil)
      base.instance_eval { attr_accessor :response }
    end

    def create_instance(body = nil)
      class_instance = new
      class_instance.response = body

      create_delegators(class_instance)
      class_instance
    end

    def create_delegators(class_instance)
      if class_instance.response && class_instance.response.respond_to?(:keys)
        class_instance.response.keys.each do |key|
          class_instance.class.def_delegator :@response, key.to_sym
          class_instance.class.def_delegator :@response, "#{key}=".to_sym
        end
      end
    end
  end
end
