module Facile::Api
  module HttpMethods
    def self.extended(base)
      base.instance_variable_set(:@defaults, {})
    end

    def url(url = nil)
      return defaults[:url] if url.nil?

      defaults[:url] = url
    end

    def body(body = nil)
      return defaults[:body] if body.nil?

      defaults[:body] = body
    end

    def headers(headers = nil)
      return defaults[:headers] if headers.nil?

      defaults[:headers] = headers
    end

    def params(params = nil)
      return defaults[:params] if params.nil?

      defaults[:params] = params
    end

    def options(options = nil)
      return defaults[:options] if options.nil?

      defaults[:options] = options
    end


    protected

    def defaults
      @defaults
    end
  end
end
