require 'forwardable'

module Facile::Api
  module RequestMethods
    include Forwardable

    def find(*args)
      id, options = args[0] || nil, args[1] || {}

      url = generate_url(id, self.url)
      req_options = request_options(url)

      body = create_request(req_options).body

      create_instance(body)
    end

    def create_request(req_options = {})
      req = Facile::Request.new(req_options)

      req.go
    end

    def generate_url(id, url)
      template = Addressable::Template.new(url)
      expanded = template.partial_expand(:id => id)

      expanded.pattern
    end

    def request_options(url)
      {
        :url => url,
        :method => :get,
        :headers => self.headers || {},
        :options => self.options || {},
        :body => self.body,
        :params => self.params || {}
      }
    end
  end
end
