class Facile::Response
  autoload :Wrapper, 'facile/response/wrapper'

  def initialize(options)
    options.each do |k,v|
      self.send("#{k}=", v)
    end

    wrap_body(raw_body)
  end

  def wrap_body(body)
    @body = ::Facile::Response::Wrapper.parse(body, headers)
  end

  def method_missing(method, *args, &block)
    if body.respond_to?(method)
      body.send(method, args.first)
    end
  end

  attr_reader :request, :response, :raw_body, :headers, :status, :body

  protected
  attr_writer :request, :response, :raw_body, :headers, :status, :body
end
