class Facile::Response::Wrapper
  autoload :Raw, 'facile/response/wrapper/raw'
  autoload :Json, 'facile/response/wrapper/json'
  autoload :Mash, 'facile/response/wrapper/mash'

  def self.parse(body, options = {})
    wrapper = new(body, options)

    wrapper.parse
  end

  def initialize(body, headers = {})
    @body, @headers = body, headers
  end

  def parse
    wrapper = "Raw"

    if headers.has_key?('content-type')
      wrapper = content_type_to_class(headers['content-type'])
    end

    klass = "Facile::Response::Wrapper::#{wrapper}".split('::').inject(Object) do |o, c|
      o.const_get(c)
    end

    klass.new(@body).parsed_body
  end

  def content_type_to_class(content_type)
    case content_type
    when /application\/json/
      'Json'
    else
      'Raw'
    end
  end

  attr_reader :body, :headers
end
